# picoFlamingo Symbian Puthon S60 Remote client
# Copyright (C) 2009
#    David Martnez Oliveira (dmo@papermint-designs.com)
#
# This application is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This application is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with EDMA.  If not, see <http://www.gnu.org/licenses/>.
#
from socket import *
from graphics import *
from appuifw import *
import appuifw
import graphics
import e32

# Global variables

keyboard_state={}
last_keycode=0
last_scancode=-1
fd=-1
pending = 0
current = ''

BT_ADDRESS = '00:0D:88:8E:9E:17'
port = 4

def draw_state():
    global fd, keyboard_state, last_scancode, pending
    global bg, current

    canvas.clear()
    canvas.blit (bg)

    if pending == 0 :
	return

    if keyboard_state[15] == 1:
	fd.send (u'next\n') 
	canvas.text((0,74),u'CMD: next')
	keyboard_state[15] = 0
	keyboard_state[14] = 0	
    elif keyboard_state[14] == 1:
	fd.send(u'prev\n')
	canvas.text((0,74),u'CMD: prev')
	keyboard_state[14] = 0
	keyboard_state[15] = 0


    canvas.text((0,86),u'DONE', 0x000080)
    canvas.text((0,110), u'CURRENT:', 0x000000)
    canvas.text((10,122), u'%s'%(current), 0x008000)
    current = ''
    last_scancode = -1
    pending = 0
    e32.ao_sleep(0.1)

    
def callback(event):
    global last_keycode
    global last_scancode, pending

    last_scancode = event['scancode']
    if event['type'] == appuifw.EEventKeyDown:
        keyboard_state[event['scancode']]=1
    elif event['type'] == appuifw.EEventKeyUp:
        keyboard_state[event['scancode']]=0
    elif event['type'] == appuifw.EEventKey:
        last_keycode=event['keycode']
    pending = 1
    draw_state()


fd = socket(AF_BT, SOCK_STREAM, BTPROTO_RFCOMM)
target = (BT_ADDRESS, port)
fd.connect(target)

canvas=appuifw.Canvas(event_callback=callback,
                      redraw_callback=lambda rect:draw_state())



appuifw.app.screen='full'
appuifw.app.body=canvas

bg = Image.open ('E:\\Images\\pf-logo.jpg')

keyboard_state[14] = 0
keyboard_state[15] = 0	
pending=1
draw_state()


lock=e32.Ao_lock()
appuifw.app.exit_key_handler=lock.signal
lock.wait()
